#include "stdafx.h"
#include "resource.h"
#include "ShUtils.h"
#include "errno.h"
#include <direct.h>
#include <io.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "shlwapi.h"

#include "winbase.h"
#include "pcre.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define curbytept ((BYTE*) filedata)
#define cursdbytept ((BYTE*) sddata)

EXTERN_C IMAGE_DOS_HEADER __ImageBase;
#define HINST_THISCOMPONENT ((HINSTANCE)&__ImageBase)

void JParseConfigFile();
void JCheckUpdateConfigFiles();
HMENU menulist[0x4000];
USHORT menuparent[0x4000];
USHORT menuflags[0x4000];		//1=display,2=exists,1024=MF_MENUBARBREAK,8=MF_MENUBREAK,16=MF_DISABLED,32=MF_GRAYED,64=MF_CHECKED,128=MF_HILITE, 256:MFS_DEFAULT, 512:MFT_RIGHTORDER
char *menutext[0x4000];
void *filedata,*sddata;
bool backgroundctx=false;

//char *extlistfn="D:\\jfiles\\util\\shell\\ctx_menu\\Release\\extlist.ini";
//char *sdlistfn="D:\\jfiles\\util\\shell\\ctx_menu\\Release\\sdlist.ini";

char *extlistfn_="\\extlist.ini";
char *sdlistfn_="\\sdlist.ini";

char extlistfn[MAX_PATH];
char sdlistfn[MAX_PATH];

bool mustreloadcfgfiles=false;

struct clist {
	USHORT type;	// 1=PCRE, 2=menu item, 3=seperator, 4=PostMessage, 5=message question
			//1024=MF_MENUBARBREAK,8=MF_MENUBREAK,16=MF_DISABLED,32=MF_GRAYED,64=MF_CHECKED,128=MF_HILITE, 256:MFS_DEFAULT, 512:MFT_RIGHTORDER
	USHORT menuid;
	union {
		pcre *regex;		//PCRE
		ULONG textoffset;	//MENU filedata[]
	};
	union {
		clist *text;		//PCRE
		ULONG actionoffset;	//MENU filedata[]
	};
	ULONG cmdstroffset;
	clist *next;
};

//struct clist configllist = {1};
clist *configllist;

struct cmdlist {
	union {
	char *action;
	clist *message;
	};
	union {
	char *text;	//for GetCommandString
	ULONG num;
	};
	HWND wind;
	ULONG flags;	//1=message
	cmdlist *next;
};

cmdlist *cmds;
cmdlist **cmdobjptrptr;

void JFreeCmds() {
	register cmdlist *a=cmds;
	register cmdlist *b;
	while(a) {
		b=a;
		a=b->next;
		free(b);
	}
	cmds=0;
	cmdobjptrptr=&cmds;
}

UINT firstCmd;

UINT JRetMenuFlags(USHORT flags) {
return ((flags&1024)?MF_MENUBARBREAK:0)|((flags&8)?MF_MENUBREAK:0)|((flags&16)?MF_DISABLED:0)|((flags&32)?MF_GRAYED:0)|((flags&64)?MF_CHECKED:0)|((flags&128)?MF_HILITE:0)|((flags&256)?MFS_DEFAULT:0)|((flags&512)?MFT_RIGHTORDER:0);
}

ULONG JInvokeCommand(LPCMINVOKECOMMANDINFO lpcmi,CStringArray &m_csaPaths) {
AFX_MANAGE_STATE(AfxGetStaticModuleState( ));

	if (!HIWORD(lpcmi->lpVerb)) {
		UINT idCmd = LOWORD(lpcmi->lpVerb);
		cmdlist *a=cmds;
		ULONG i=0;		
		while(idCmd-- && a) {
			if(a->flags&1) {
				/* i=a->num;
				while(idCmd && i) { i--;idCmd--;}
				if(idCmd+1) {
					//i=a->num-i;
					break;
				} */
				if(idCmd>=(a->num-1)) {
					idCmd-=(a->num-1);
				}
				else {
					i=((a->num-1)-idCmd);
					break;
				}
			}
			a=a->next;
		}
		if(!a) return NOERROR;
		if(a->flags&1){
			PostMessage(a->wind,(a->message)->actionoffset,2+((a->message)->cmdstroffset<<16),i);
		}
		else {
			int iFiles = m_csaPaths.GetSize();
			for (int i=0; i < iFiles; i++) {
				CString csFile;
				char cmd[MAX_PATH*2];
				lstrcpy(cmd,m_csaPaths.GetAt(i));
				PathRemoveBackslashA(cmd);
				csFile.Format("%s \"%s\"", a->action, cmd);
				STARTUPINFO st;
				PROCESS_INFORMATION pt;
				GetStartupInfo(&st);
				//MessageBox(0,(LPTSTR) (LPCTSTR)csFile,0,0);
				CreateProcess(0,(LPTSTR) (LPCTSTR)csFile,0,0,0,0,0,0,&st,&pt);
			}
		}
	}
return NOERROR;
}

void JGetCommandString(UINT idCmd, LPSTR pszName, UINT cchMax) {
	cmdlist *a=cmds;
	UINT midCmd=idCmd;
	ULONG i=0;
	while(idCmd-- && a) {
		if(a->flags&1) {
			/* i=a->num;
			while(idCmd && i) { i--;idCmd--;}
			if(idCmd+1) {
				//i=a->num-i;
				break;
			} */
			if(idCmd>=(a->num-1)) {
				idCmd-=(a->num-1);
			}
			else {
				i=((a->num-1)-idCmd);
				break;
			}
		}
		a=a->next;
	}
	if(!a) return;
	if(a->flags&1){
		HANDLE fm=CreateFileMapping((HANDLE) 0xFFFFFFFF,0,PAGE_READWRITE,0, cchMax,"JGRShellExtFileMappingObject2");
		if(!fm) return;
		void *mp=MapViewOfFile(fm,FILE_MAP_ALL_ACCESS,0,0,0);
		if(!fm) { CloseHandle(fm); return; }
		((ULONG*) mp)[0]=0;
		((ULONG*) mp)[1]=cchMax;
		SendMessage(a->wind,(a->message)->actionoffset,1+((a->message)->cmdstroffset<<16),i);
		strncpy(pszName,&((char*) mp)[0], cchMax);
		UnmapViewOfFile(mp);
		CloseHandle(fm);
	}
	else strncpy(pszName,a->text, cchMax);
}

void JRecursiveParse(clist *nextclist, UINT &indexMenu,UINT &idCmdFirst,CStringArray &m_csaPaths) {
	UINT mpos,mflags;
	bool ifpassed=false;
	if(!nextclist) return;
	do {
		switch (nextclist->type&7) {
			case 1:	 {//pcre
				if(! (nextclist->type&256)) ifpassed=false;
				else if(ifpassed) break;
				if(nextclist->type&8 && backgroundctx) break;
				if(nextclist->type&1024 && !backgroundctx) break;
				if(nextclist->regex) {
					int iFiles = m_csaPaths.GetSize();
					bool additem=true;
					while(iFiles--) {
						int ovector[3];
						int rc=pcre_exec(nextclist->regex, 0, (LPTSTR) (LPCTSTR)m_csaPaths.GetAt(iFiles),strlen((LPTSTR) (LPCTSTR)m_csaPaths.GetAt(iFiles)), 0, PCRE_NOTEMPTY, ovector, 3);
	/* 					char *errmess= (char*) malloc(0x1000);
						_snprintf(errmess, 0x1000, "PCRE failed to match regular expression.\nError:%d",rc);
						MessageBox(0,errmess,0,MB_OK);
						free(errmess); */
						if(rc<1) {
							additem=false;
							break;
						}
					}
					if(!additem) break;
				}
				ifpassed=true;
				JRecursiveParse(nextclist->text,indexMenu,idCmdFirst,m_csaPaths);
			break;
			}
			case 4: {
				//MessageBox(0,"Message...",0,0);
				HANDLE fh=CreateFile((char*) &curbytept[nextclist->textoffset],GENERIC_READ,FILE_SHARE_READ, 0, OPEN_EXISTING, 0, 0);
				if(fh==INVALID_HANDLE_VALUE) break;
				HWND wind;
				ReadFile(fh,&wind,4,(DWORD*)&mpos,0);
				CloseHandle(fh);

				int iFiles = m_csaPaths.GetSize();
				#define stroffset 24
				ULONG curlen=stroffset;
				while(iFiles--) {
					curlen+=strlen((LPTSTR) (LPCTSTR)m_csaPaths.GetAt(iFiles))+1;
				}
				if(!(menuflags[nextclist->menuid]&2)) break;
				if(!menulist[nextclist->menuid]) menulist[nextclist->menuid]=CreateMenu();
				register USHORT curid=nextclist->menuid;
				while(menuflags[curid]&2&&curid) {
					menuflags[curid]|=1;
					curid=menuparent[curid];
				}
				HANDLE fm=CreateFileMapping((HANDLE) 0xFFFFFFFF,0,PAGE_READWRITE,0, curlen,"JGRShellExtFileMappingObject1");
				if(!fm) break;
				void *mp=MapViewOfFile(fm,FILE_MAP_ALL_ACCESS,0,0,0);
				if(!fm) { CloseHandle(fm); break; }
				((ULONG*) mp)[0]=0;
				//nextclist->actionoffset
				((ULONG*) mp)[1]= (ULONG) menulist[nextclist->menuid];
				((ULONG*) mp)[2]=idCmdFirst;
				if(nextclist->menuid) ((ULONG*) mp)[3]=-1;
				else ((ULONG*) mp)[3]=indexMenu;
				
				((ULONG*) mp)[4] = iFiles = m_csaPaths.GetSize();
				((ULONG*) mp)[5] = curlen-stroffset;
				char *curlsmpt= (char*) (&((ULONG*) mp)[6]);
				while(iFiles--) {
					strcpy(curlsmpt,(LPTSTR) (LPCTSTR)m_csaPaths.GetAt(iFiles));
					curlsmpt+=strlen((LPTSTR) (LPCTSTR)m_csaPaths.GetAt(iFiles))+1;
					*(curlsmpt-1)=13;
				}
				*(curlsmpt-1)=0;
/* 				char *errmess= (char*) malloc(0x1000);
				_snprintf(errmess, 0x1000, "Sending Message...\nHWND: 0x%X\nMSG: 0x%X",wind,nextclist->actionoffset);
				MessageBox(0,errmess,0,MB_OK);
				free(errmess); */
				SendMessage(wind,nextclist->actionoffset,0+(nextclist->cmdstroffset<<16),0);

				if(((ULONG*) mp)[0]) {
					menulist[nextclist->menuid]=(HMENU) ((ULONG*) mp)[1];
					if(!nextclist->menuid) indexMenu=((ULONG*) mp)[3];
					//for(int i=0;i<(((ULONG*) mp)[2]-idCmdFirst);i++) {
						*cmdobjptrptr=(cmdlist*)malloc(sizeof(cmdlist));
						(*cmdobjptrptr)->message=nextclist;
						(*cmdobjptrptr)->wind=wind;
						(*cmdobjptrptr)->num=(((ULONG*) mp)[2]-idCmdFirst);
						(*cmdobjptrptr)->flags=1;
						cmdobjptrptr=&((*cmdobjptrptr)->next);
						//nextclist->textoffset=(ULONG) wind;
					//}
					idCmdFirst=((ULONG*) mp)[2];
				}

				UnmapViewOfFile(mp);
				CloseHandle(fm);
			break;
			}
			case 2:
			case 3:
			{
				if(curbytept[nextclist->textoffset]&&(menuflags[nextclist->menuid]&2)) {
					if(!menulist[nextclist->menuid]) menulist[nextclist->menuid]=CreateMenu();
					mflags=MF_BYPOSITION|JRetMenuFlags(nextclist->type);
					if((nextclist->type&7)==2) {
						if(nextclist->menuid) mpos=-1;
						else mpos=indexMenu++;
						/* mflags= */InsertMenu(menulist[nextclist->menuid], mpos, MF_STRING|mflags, idCmdFirst++, &((char*)filedata)[nextclist->textoffset]);
	/* 					if(!mflags) {
							char *errmess= (char*) malloc(0x1000);
							_snprintf(errmess, 0x1000, "Unable to insert menu item.\nError:%d",GetLastError());
							MessageBox(0,errmess,0,MB_OK);
							free(errmess);
						} */
						//MessageBox(0,"Got Here", 0, 0);
						*cmdobjptrptr=(cmdlist*)malloc(sizeof(cmdlist));
						(*cmdobjptrptr)->action=&((char*)filedata)[nextclist->actionoffset];
						(*cmdobjptrptr)->text=&((char*)filedata)[nextclist->cmdstroffset];
						(*cmdobjptrptr)->flags=0;
						cmdobjptrptr=&((*cmdobjptrptr)->next);
						register USHORT curid=nextclist->menuid;
						while(menuflags[curid]&2&&curid) {
							menuflags[curid]|=1;
							curid=menuparent[curid];
						}
					}
					else {
						if(nextclist->menuid) mpos=-1;
						else mpos=indexMenu++;
						InsertMenu(menulist[nextclist->menuid], mpos, MF_SEPARATOR|mflags, 0, 0);
					}
				}
			break;
			}
			case 5: {
				if(! (nextclist->type&256)) ifpassed=false;
				else if(ifpassed) break;
				if(nextclist->type&8 && backgroundctx) break;
				if(nextclist->type&1024 && !backgroundctx) break;
				//MessageBox(0,"Message...",0,0);
				HANDLE fh=CreateFile((char*) &curbytept[nextclist->textoffset],GENERIC_READ,FILE_SHARE_READ, 0, OPEN_EXISTING, 0, 0);
				if(fh==INVALID_HANDLE_VALUE) break;
				HWND wind;
				ReadFile(fh,&wind,4,(DWORD*)&mpos,0);
				CloseHandle(fh);

				int iFiles = m_csaPaths.GetSize();
				#undef stroffset
				#define stroffset 16
				ULONG curlen=stroffset;
				while(iFiles--) {
					curlen+=strlen((LPTSTR) (LPCTSTR)m_csaPaths.GetAt(iFiles))+1;
				}
				HANDLE fm=CreateFileMapping((HANDLE) 0xFFFFFFFF,0,PAGE_READWRITE,0, curlen,"JGRShellExtFileMappingObject3");
				if(!fm) break;
				void *mp=MapViewOfFile(fm,FILE_MAP_ALL_ACCESS,0,0,0);
				if(!fm) { CloseHandle(fm); break; }
				((ULONG*) mp)[0]=0;
				((ULONG*) mp)[1] = iFiles = m_csaPaths.GetSize();
				((ULONG*) mp)[2] = curlen-stroffset;
				((ULONG*) mp)[3] = 0;
				char *curlsmpt= (char*) (&((ULONG*) mp)[4]);
				while(iFiles--) {
					strcpy(curlsmpt,(LPTSTR) (LPCTSTR)m_csaPaths.GetAt(iFiles));
					curlsmpt+=strlen((LPTSTR) (LPCTSTR)m_csaPaths.GetAt(iFiles))+1;
					*(curlsmpt-1)=13;
				}
				*(curlsmpt-1)=0;
/* 				char *errmess= (char*) malloc(0x1000);
				_snprintf(errmess, 0x1000, "Sending Message...\nHWND: 0x%X\nMSG: 0x%X",wind,nextclist->actionoffset);
				MessageBox(0,errmess,0,MB_OK);
				free(errmess); */
				SendMessage(wind,nextclist->cmdstroffset,3+(nextclist->menuid<<16),0);
				if(((ULONG*) mp)[0] && ((ULONG*) mp)[3]) {
					JRecursiveParse(nextclist->text,indexMenu,idCmdFirst,m_csaPaths);
				}

				UnmapViewOfFile(mp);
				CloseHandle(fm);
			}
		}
	}
	while(nextclist=nextclist->next);
}

ULONG JCreateShellExtMenu(HMENU hMenu,UINT indexMenu,UINT idCmdFirst,CStringArray &m_csaPaths) {
	//MessageBoxA(0,"JCreateShellExtMenu()",0,0);
	JCheckUpdateConfigFiles();
	JFreeCmds();
	firstCmd=idCmdFirst;
	//clist *nextpcre,*nexttext;
	ZeroMemory(&menulist,sizeof(menulist));
	menulist[0]=hMenu;
	//clist *nextclist=&configllist;
	cmdobjptrptr=&cmds;
	UINT mpos;//,mflags;
	JRecursiveParse(configllist,indexMenu,idCmdFirst,m_csaPaths);

	*cmdobjptrptr=0;
	bool msgb=true;
	for(int i=1;i<0x4000;i++) {
		if((menuflags[i]&3)!=3) continue;
		menuflags[i]&= ~1;
		if(menuparent[i]) mpos=-1;
		else mpos=indexMenu++;
		//MessageBox(0,menutext[i],0,0);
		/* mflags= */InsertMenu(menulist[menuparent[i]], mpos, MF_POPUP|MF_BYPOSITION|JRetMenuFlags(menuflags[i]), (UINT) menulist[i], menutext[i]);
/* 			if(!mflags) {
			char *errmess= (char*) malloc(0x1000);
			_snprintf(errmess, 0x1000, "Unable to insert menu item.\nError:%d",GetLastError());
			MessageBox(0,errmess,0,MB_OK);
			free(errmess);
		} */

/* 		if(msgb) {
			char *errmess= (char*) malloc(0x1000);
			_snprintf(errmess, 0x1000, "Inserting Submenu.\nParent:%d\nIndex:%d\nId:%d\nText:%s",menulist[menuparent[i]],indexMenu-1,menulist[i],menutext[i]);
			if(MessageBox(0,errmess,0,MB_OKCANCEL)==IDCANCEL) msgb=false;
			free(errmess);
		} */
	}
	return idCmdFirst-firstCmd;
}

USHORT JParseExtraFlags(void *lst,ULONG *curpt) {
	USHORT sdflags=0;
	--*curpt;
	while(true) {
		++*curpt;
		if(((BYTE*) lst)[*curpt]=='>') {sdflags|=8; continue;}//MF_MENUBREAK
		if(((BYTE*) lst)[*curpt]=='&') {sdflags|=16; continue;}//MF_DISABLED
		if(((BYTE*) lst)[*curpt]=='#') {sdflags|=32; continue;}//MF_GRAYED
		if(((BYTE*) lst)[*curpt]=='*') {sdflags|=64; continue;}//MF_CHECKED
		if(((BYTE*) lst)[*curpt]=='$') {sdflags|=128; continue;}//MF_HILITE
		if(((BYTE*) lst)[*curpt]=='+') {sdflags|=256; continue;}//MFS_DEFAULT
		if(((BYTE*) lst)[*curpt]=='_') {sdflags|=512; continue;}//MFT_RIGHTORDER
		if(((BYTE*) lst)[*curpt]=='<') {sdflags|=1024; continue;}//MF_MENUBARBREAK
		if(((BYTE*) lst)[*curpt]==':') {sdflags|=0x8000; continue;}//Default Command String = Action String, not Text String
/* 		if(sdflags) {
			char *errmess= (char*) malloc(0x20);
			_snprintf(errmess, 0x20, "Flags: 0x%X",sdflags);
			MessageBox(0,errmess,0,MB_OK);
			free(errmess);
		} */
		return sdflags;
	}


}

void JParseSDirConfigFile() {
	ZeroMemory(&menulist,sizeof(menulist));
	ZeroMemory(&menuflags,sizeof(menuflags));
	ZeroMemory(&menutext,sizeof(menutext));
	menuflags[0]=3;
	HANDLE fh=CreateFile(sdlistfn,GENERIC_READ,FILE_SHARE_READ, 0, OPEN_EXISTING, 0, 0);
	if(fh==INVALID_HANDLE_VALUE) { MessageBox(0,/*"Cant't find sdlist.ini"*/sdlistfn,0,MB_OK); return; }
		//parse file
	UINT filesize=GetFileSize(fh,0);
	if(filesize<=0x100000) {
		ULONG bytesleft=filesize;
		if(sddata) free(sddata);
		sddata=malloc(filesize+1);
		ULONG nbr=0,curpt=0,st1;
		while(bytesleft) {
			if(!ReadFile(fh,&(cursdbytept[nbr]),bytesleft,&nbr,0)) break;
			bytesleft-=nbr;
			curpt+=nbr;
		}
		cursdbytept[curpt]=0;
		//MessageBox(0,(char*) cursdbytept,0,0);
		if(curpt>0) {
			curpt=0;
			while(cursdbytept[curpt]) {
				while(cursdbytept[curpt]==13 || cursdbytept[curpt]==10) curpt++;
				
/* 				cursdbytept[curpt-1]='#';
				MessageBox(0,(char*)&cursdbytept[curpt-1],0,0); */

				//MessageBox(0,"Adding Subdir 1",0,0);
				UINT sdflags=JParseExtraFlags(sddata,&curpt);

				st1=curpt;
				while(cursdbytept[curpt]&&cursdbytept[curpt]!=13&&cursdbytept[curpt]!=',')curpt++;
				if(cursdbytept[curpt]==13||!cursdbytept[curpt]) continue;
				cursdbytept[curpt++]=0;
				UINT mid=strtoul((char*) &cursdbytept[st1],NULL,(cursdbytept[st1]=='0'&&(cursdbytept[st1+1]|0x20)=='x')?16:10);
	
				//MessageBox(0,"Adding Subdir 2",0,0);

				st1=curpt;
				while(cursdbytept[curpt]&&cursdbytept[curpt]!=13&&cursdbytept[curpt]!=',')curpt++;
				if(cursdbytept[curpt]==13||!cursdbytept[curpt]) continue;
				cursdbytept[curpt++]=0;
				UINT pid=strtoul((char*) &cursdbytept[st1],NULL,(cursdbytept[st1]=='0'&&(cursdbytept[st1+1]|0x20)=='x')?16:10);

				//MessageBox(0,"Adding Subdir 3",0,0);

				st1=curpt;
				while(cursdbytept[curpt]&&cursdbytept[curpt]!=13)curpt++;
				if(cursdbytept[curpt]!=0)cursdbytept[curpt++]=0;
				if(pid>=0x4000||!(menuflags[pid]&2)) continue;
				if(mid>=0x4000) continue;
				menuflags[mid]=2|sdflags;
				menutext[mid]=(char*)&cursdbytept[st1];
				menuparent[mid]=pid;
				//MessageBox(0,"Added Subdir",0,0);
			}
		}
	}
	CloseHandle(fh);
}

void JFreeClistLList(clist *ps) {
	if(!ps) return;
	if(ps->next)JFreeClistLList(ps->next);
	if(ps->text&&(((ps->type&7)==1)||((ps->type&7)==5)))JFreeClistLList(ps->text);
	if(ps->regex&&((ps->type&7)==1)) (*pcre_free)(ps->regex);
	free(ps);
}

void JClearUp() {
	JFreeClistLList(configllist);
	configllist=0;
	JFreeCmds();
}

void JClearUpFinal() {
	JClearUp();
	if(filedata) free(filedata);
	if(sddata) free(sddata);
	filedata=sddata=0;
	mustreloadcfgfiles=true;
}

void JRecursiveParseConfigFile(ULONG &curpt,ULONG &curline, clist** textstore, clist*** retnextseqclist) {
	clist* newcl;
	ULONG st1,tempd;
	while(curbytept[curpt]) {
		curline++;
		if(curbytept[curpt]==10) curpt++;
		if(curbytept[curpt]==13) {curpt++;continue;}
		if(curbytept[curpt]=='?') {
			pcre *regex;
			curpt++;
			tempd=JParseExtraFlags(filedata,&curpt);
			if(curbytept[curpt]=='!') {
				newcl=(clist*) malloc(sizeof(clist));
				newcl->type=5|tempd;
				newcl->next=NULL;
				newcl->text=NULL;

				st1=++curpt;
				while(curbytept[curpt]&&curbytept[curpt]!=13&&curbytept[curpt]!=',')curpt++;
				if(curbytept[curpt]==13||!curbytept[curpt]) continue;
				curbytept[curpt++]=0;
				newcl->cmdstroffset=strtoul((char*) &curbytept[st1],NULL,(curbytept[st1]=='0'&&(curbytept[st1+1]|0x20)=='x')?16:10);
	
				st1=curpt;
				while(curbytept[curpt]&&curbytept[curpt]!=13&&curbytept[curpt]!=',')curpt++;
				if(curbytept[curpt]==13||!curbytept[curpt]) continue;
				curbytept[curpt++]=0;
				newcl->menuid=strtoul((char*) &curbytept[st1],NULL,(curbytept[st1]=='0'&&(curbytept[st1+1]|0x20)=='x')?16:10);
	
				newcl->textoffset=curpt;
				while(curbytept[curpt]&&curbytept[curpt]!=13)curpt++;
				if(curbytept[curpt]!=0)curbytept[curpt++]=0;
				//curbytept[curpt++]=0;
	
				if(tempd&256) {
					**retnextseqclist=newcl;
					textstore=&(newcl->text);
					*retnextseqclist=&(newcl->next);
				}
				else {
					*textstore=newcl;
					textstore=&(newcl->next);
					JRecursiveParseConfigFile(curpt,curline,&(newcl->text),&textstore);
				}
			}
			else if(curbytept[curpt]==')') {
				while(curbytept[curpt]&&curbytept[curpt]!=13)curpt++;
				return;
			}
			else {
				regex=0;
				if(curbytept[curpt]=='?') {
					st1=++curpt;
					if(curbytept[curpt]&&curbytept[curpt]!=13) {
						while(curbytept[curpt]&&curbytept[curpt]!=13)curpt++;
						if(curbytept[curpt]!=0)curbytept[curpt++]=0;
						const char *error;
						int erroffset;
						if(!(regex=pcre_compile((char*) &curbytept[st1], PCRE_NO_AUTO_CAPTURE|PCRE_CASELESS, &error, &erroffset, 0))) {
							char *errmess= (char*) malloc(0x1000);
							_snprintf(errmess, 0x1000, "PCRE failed to compile regular expression.\nError:%s\nLine number:%d\nLine offset:%d",(char*)error,curline,erroffset);
							MessageBox(0,errmess,0,MB_OK);
							free(errmess);
							continue;
						}
					}
				}
				newcl=(clist*) malloc(sizeof(clist));
				newcl->type=1|tempd;
				newcl->next=NULL;
				newcl->text=NULL;
				newcl->regex=regex;
				if(tempd&256) {
					**retnextseqclist=newcl;
					textstore=&(newcl->text);
					*retnextseqclist=&(newcl->next);
				}
				else {
					*textstore=newcl;
					textstore=&(newcl->next);
					JRecursiveParseConfigFile(curpt,curline,&(newcl->text),&textstore);
				}
			}
		}
		else if(curbytept[curpt]==';') {
			while(curbytept[curpt]&&curbytept[curpt]!=13)curpt++;
		}
		else if(curbytept[curpt]=='!') {
			newcl=(clist*) malloc(sizeof(clist));
			newcl->type=4;
			newcl->next=NULL;

			st1=++curpt;
			while(curbytept[curpt]&&curbytept[curpt]!=13&&curbytept[curpt]!=',')curpt++;
			if(curbytept[curpt]==13||!curbytept[curpt]) continue;
			curbytept[curpt++]=0;
			newcl->actionoffset=strtoul((char*) &curbytept[st1],NULL,(curbytept[st1]=='0'&&(curbytept[st1+1]|0x20)=='x')?16:10);

			st1=curpt;
			while(curbytept[curpt]&&curbytept[curpt]!=13&&curbytept[curpt]!=',')curpt++;
			if(curbytept[curpt]==13||!curbytept[curpt]) continue;
			curbytept[curpt++]=0;
			newcl->menuid=strtoul((char*) &curbytept[st1],NULL,(curbytept[st1]=='0'&&(curbytept[st1+1]|0x20)=='x')?16:10);

			st1=curpt;
			while(curbytept[curpt]&&curbytept[curpt]!=13&&curbytept[curpt]!=',')curpt++;
			if(curbytept[curpt]==13||!curbytept[curpt]) continue;
			curbytept[curpt++]=0;
			newcl->cmdstroffset=strtoul((char*) &curbytept[st1],NULL,(curbytept[st1]=='0'&&(curbytept[st1+1]|0x20)=='x')?16:10);

			newcl->textoffset=curpt;
			while(curbytept[curpt]&&curbytept[curpt]!=13)curpt++;
			if(curbytept[curpt]!=0)curbytept[curpt++]=0;
			//curbytept[curpt++]=0;

			*textstore=newcl;
			textstore=&(newcl->next);
		}
		else {
			newcl=(clist*) malloc(sizeof(clist));
			newcl->type=2;
			newcl->next=NULL;

			newcl->type|=JParseExtraFlags(filedata,&curpt);

			BYTE delim=curbytept[curpt++];

			st1=curpt;
			while(curbytept[curpt]&&curbytept[curpt]!=delim&&curbytept[curpt]!=13)curpt++;
			if(curbytept[curpt]==13||!curbytept[curpt]) {
				while(curbytept[curpt]&&curbytept[curpt]!=13)curpt++;
				free(newcl);
				continue;
			}
			curbytept[curpt++]=0;
			newcl->menuid=strtoul((char*) &curbytept[st1],NULL,(curbytept[st1]=='0'&&(curbytept[st1+1]|0x20)=='x')?16:10);

			//MessageBox(0,"Adding Item 1",0,0);
			if(curbytept[curpt]==delim) {
				while(curbytept[curpt]&&curbytept[curpt]!=13)curpt++;
				newcl->type|=1;
				newcl->textoffset=0;
				newcl->actionoffset=0;
			}
			else {
				newcl->textoffset=curpt;
				while(curbytept[curpt]&&curbytept[curpt]!=delim&&curbytept[curpt]!=13)curpt++;
				if(curbytept[curpt]==13||!curbytept[curpt]) {
					while(curbytept[curpt]&&curbytept[curpt]!=13)curpt++;
					free(newcl);
					continue;
				}
				curbytept[curpt++]=0;

				//MessageBox(0,"Adding Item 2",0,0);

				newcl->actionoffset=curpt;
				while(curbytept[curpt]&&curbytept[curpt]!=delim&&curbytept[curpt]!=13)curpt++;
				if(curbytept[curpt]==13||!curbytept[curpt]) {
					//while(curbytept[curpt]&&curbytept[curpt]!=13)curpt++;
					newcl->cmdstroffset=(newcl->type&0x8000)?newcl->actionoffset:newcl->textoffset;
					curbytept[curpt++]=0;
				}
				else {
					curbytept[curpt++]=0;

					newcl->cmdstroffset=curpt;
					while(curbytept[curpt]&&curbytept[curpt]!=delim&&curbytept[curpt]!=13)curpt++;
					if(curbytept[curpt]==delim) {
						curbytept[curpt++]=0;
						while(curbytept[curpt]!=13&&curbytept[curpt]) curpt++;
						if(curbytept[curpt]==13) curpt++;
					}
					else curbytept[curpt++]=0;
				}

				//MessageBox(0,"Added Item",0,0);
			}

			*textstore=newcl;
			textstore=&(newcl->next);
		}
	}
}

void JParseConfigFile() {
	JClearUp();
	HANDLE fh=CreateFile(extlistfn,GENERIC_READ,FILE_SHARE_READ, 0, OPEN_EXISTING, 0, 0);
	if(fh==INVALID_HANDLE_VALUE) return;
	//clist* nextclist=&configllist;
	clist** textstore=&configllist;
	//parse file
	UINT filesize=GetFileSize(fh,0);
	if(filesize<=0x100000) {
		ULONG bytesleft=filesize;
		if(filedata) free(filedata);
		filedata=malloc(filesize+1);
		ULONG nbr=0,curpt=0,st1;
		while(bytesleft) {
			if(!ReadFile(fh,&(curbytept[nbr]),bytesleft,&nbr,0)) break;
			bytesleft-=nbr;
			curpt+=nbr;
		}
		curbytept[curpt]=0;
		
		//MessageBox(0,(char*) curbytept,0,0);

		if(curpt>0) {
			curpt=0;
			ULONG curline=0;
			clist *elseiftrap=NULL;
			clist **elseifdump=&elseiftrap;
			JRecursiveParseConfigFile(curpt,curline,textstore,&elseifdump);
			if(elseiftrap) {
				JFreeClistLList(elseiftrap);
				MessageBox(0,"Warning: else without preceeding if\nextlist.ini",0,0);
			}
		}
	}
	CloseHandle(fh);
}

FILETIME sdtime,exttime;

void JCheckUpdateConfigFiles() {
	WIN32_FILE_ATTRIBUTE_DATA sdattrib,extattrib;
	static bool files_=false;

	if(!files_) {
		GetModuleFileName(HINST_THISCOMPONENT, extlistfn, MAX_PATH);
		ODS(extlistfn);
		PathRemoveFileSpec(extlistfn);
		ODS(extlistfn);
		strcpy(sdlistfn,extlistfn);
		strcat(extlistfn,extlistfn_);
		ODS(extlistfn);
		strcat(sdlistfn,sdlistfn_);
		ODS(sdlistfn);
		files_=true;
	}


	//GetFileTime(extlistfn,0,0,&exttime1);
	//GetFileTime(sdlistfn,0,0,&exttime1);
	GetFileAttributesEx(extlistfn,GetFileExInfoStandard,&extattrib);
	GetFileAttributesEx(sdlistfn,GetFileExInfoStandard,&sdattrib);
	if((CompareFileTime(&(sdattrib.ftLastWriteTime),&sdtime)==1)||(CompareFileTime(&(extattrib.ftLastWriteTime),&exttime)==1)||mustreloadcfgfiles) {
		ODS("Rereading Config Files");
		sdtime=sdattrib.ftLastWriteTime;
		exttime=extattrib.ftLastWriteTime;
		JParseSDirConfigFile();
		JParseConfigFile();
		mustreloadcfgfiles=false;
		ODS("Parsed Config Files");
	}
}
